VERSION 5.00
Begin VB.Form FormMain 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   Caption         =   "Spell Time Demo using Virtual Basic"
   ClientHeight    =   3195
   ClientLeft      =   210
   ClientTop       =   3285
   ClientWidth     =   7365
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3195
   ScaleWidth      =   7365
   Begin VB.Menu File 
      Caption         =   "&File"
   End
   Begin VB.Menu Word 
      Caption         =   "&Word"
   End
End
Attribute VB_Name = "FormMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
   Option Explicit

   Const MAX_LINES = 4
   Const MAX_LINE_LEN = 240

   Dim InputFile As String
   Dim ReadOnly As Integer
   
   Dim TotalWords As Long, WrongWords As Long
   Dim TextLine(4) As String         ' upto 4 lines will be displayed at one time
   Dim CurWord As String             ' current word
   Dim StatusLine As String * 160    ' content of the status line

   Dim CurLine As Integer            ' current line number in the TextLine array
   Dim LineIndex As Long          ' number of characters checked in the current line
   Dim LineLen As Integer
   Dim WordIndex As Long
   Dim WordLen As Integer
   Dim ErrorCode As Integer
   Dim InputLine As String
   
   

Private Sub File_Click()
   Dim iFile As Integer, oFile As Integer
   Dim i As Integer
   Dim OutFile As String
   Dim ExitRequest
   Dim result As StResult
   Dim temp As Integer
   Dim code As Integer
   Dim NewWord As String
   Dim BackupFile As String
   

   Rem ****** Accept the file name to spell check *******
   FormFile.Show 1
   ReadOnly = FormFile.DlgReadOnly
   
   InputFile = RTrim$(FormFile.DlgFile)
   
   
   If Len(InputFile) = 0 Then Exit Sub

   Rem ***************************************************
   Rem Open input file to Spell Check
   Rem ***************************************************
   iFile = 1
   oFile = 2
   
   ErrorCode = 0
   On Error GoTo ErrorHandler
   Open InputFile For Input As iFile
   On Error GoTo 0
   If ErrorCode Then
      MsgBox "Input File Not Found!"
      Exit Sub
   End If
   

   Rem ********* open the output file *************
   If ReadOnly = False Then
      OutFile = ModifyExt(InputFile, ".STT")
      On Error GoTo ErrorHandler
      Kill OutFile          'delete any existing file
      On Error GoTo 0

      Open OutFile For Output As oFile
   End If

   Rem ******** Initialize the spell checker
   CurLine = MAX_LINES - 1
   For i = 0 To MAX_LINES - 1
     TextLine(i) = ""
   Next i
   TotalWords = 0
   WrongWords = 0
   CurWord = ""
   ExitRequest = False
   StatusLine = "Checking..."   ' show status
   Form_paint                   ' print status
   temp = StClearHist()         ' reset spell checker history buffer (optiona)
   

   
NEXT_LINE:                      ' process each line
   If EOF(iFile) Then GoTo END_FILE
   Line Input #iFile, InputLine

   TextLine(CurLine) = InputLine ' copy to the display array
   LineLen = Len(InputLine)

   LineIndex = 0                ' number of characters checked in this line

   If ExitRequest = False Then  ' stop if user clicks 'exit' on Spell Time window
      Do
        Rem Extract the next word from the current line
        CurWord = Space(ST_MAX_WORD_LEN + 1) ' allocate enough space for the output word
        WordLen = StParseLine(InputLine, CurWord, WordIndex, LineIndex, LineLen)
        If WordLen = 0 Then Exit Do    ' end of line
        
        Rem Discard terminating NULL stuffed by SPELL.DLL ****
        CurWord = DiscardNull(CurWord)

        '  Check this word first without showin alternates
        If ST_FALSE = SpellWord(CurWord, 0, hWnd, result) Then
           
           Rem ***** A Misspelled word found *********
           If (result.code And (ST_EXIT Or ST_ERROR)) Then
              ExitRequest = True
              Exit Do
           End If
        
           StatusLine = "Correction..." ' begin alternate word selection
           Form_paint
        
           temp = SpellWord(CurWord, ST_INTERACTIVE, hWnd, result)

           code = result.code          ' result code

           If (code And (ST_EXIT Or ST_ERROR)) Then
              ExitRequest = True
              Exit Do
           End If

           
           Rem ***** replace the incorrect word *******
           If (ReadOnly = False) Then
              Rem discard terminating NULL from the replacement word
              NewWord = DiscardNull(result.replace)
              
              If (Len(NewWord) > 0) Then
                 TextLine(CurLine) = Left(InputLine, WordIndex) & NewWord & Right(InputLine, LineLen - LineIndex)
                 InputLine = TextLine(CurLine)
                 Rem adjust line length and line index
                 LineLen = Len(InputLine)
                 LineIndex = LineIndex - WordLen + Len(NewWord)
                 CurWord = ""
              End If
           End If

           If (code And (ST_IGNORE Or ST_REPLACE Or ST_ADD Or ST_INPUT)) Then WrongWords = WrongWords + 1
           
           StatusLine = "Checking..."
           Form_paint
        End If
        TotalWords = TotalWords + 1
      Loop
   End If

   Rem ***** write the corrected line to the output file ***
   If (ReadOnly = False) Then
     Print #oFile, InputLine
   End If

   
   Rem **** advance line counter and goto read next line
   CurLine = CurLine + 1
   If CurLine >= MAX_LINES Then CurLine = 0
   If (ReadOnly = False Or ExitRequest = False) Then GoTo NEXT_LINE


END_FILE:
   Close #iFile                        ' close the input file

   If (ReadOnly = False) Then
      Close #oFile                     ' close the output file
      BackupFile = ModifyExt(InputFile, ".ST") ' save input file with .ST extension
      Kill BackupFile                  ' delete any old backup file
      Name InputFile As BackupFile     ' rename input file
      Name OutFile As InputFile        ' input file now contains corrected text
   End If

   ' ********* Reset Screen Variables
   WordIndex = 0
   LineLen = 0
   For i = 0 To MAX_LINES - 1
      TextLine(i) = ""
   Next i
   CurLine = 0
   
   StatusLine = "Words Checked: " & Str(TotalWords) & ", Number of Incorrect Words: " & Str(WrongWords)
   Form_paint                          ' show status
 
   Exit Sub

Rem **************************************************
ErrorHandler:
   ErrorCode = Err
   Resume Next

End Sub

Private Sub Form_Load()
  Dim i As Integer

  Rem Initialize the text line array
  For i = 0 To i < MAX_LINES
    TextLine(i) = ""
  Next i

  StatusLine = "" ' initialize the status line

  CurLine = 0   ' current line to be displayed in the line array
  
End Sub

Private Sub Form_paint()
   Dim WinHeight As Integer, WinWidth As Integer
   Dim RectLeft As Integer, RectRight As Integer
   Dim RectTop As Integer, RectBottom As Integer
   Dim HeightAdj As Integer
   Dim StatusLineY
   Dim BorderWidth

   Cls                       ' clear window
   '******* Calculate window dimensions *********
   FontName = "Courier New"     ' use fixed pitch font

   GoSub GetWinDimensions  ' Get window dimensions
   GoSub DisplayStatus     ' Display the status line
   GoSub DisplayLines      ' display the text lines

   ' draw separator lines
   CurrentX = RectLeft
   CurrentY = RectTop - TextHeight("X") / 4
   Line -(RectRight, CurrentY)

   CurrentX = RectLeft
   CurrentY = RectBottom + TextHeight("X") / 4
   Line -(RectRight, CurrentY)

   CurrentX = RectLeft
   CurrentY = StatusLineY - TextHeight("X") / 4
   Line -(RectRight, CurrentY)

   
   FontName = "system"       ' restore the system font
   
   Exit Sub

Rem *************************************************
Rem Get the dimensions of the form
Rem *************************************************
GetWinDimensions:

   WinHeight = ScaleHeight / TextHeight("X") 'window height in number of line
   WinWidth = ScaleWidth / TextWidth("X") ' window widht in number of line

   WinHeight = WinHeight - 1 ' use last line for status info
   If WinHeight < 0 Then WinHeight = 0
   If WinHeight > MAX_LINES Then
      HeightAdj = (WinHeight - MAX_LINES) * TextHeight("X")
      WinHeight = MAX_LINES
   Else
      HeightAdj = 0
   End If

   If WinWidth <= 0 Then WinWidth = 1

   RectLeft = TextWidth("X") / 2
   RectRight = RectLeft + WinWidth * TextWidth("X")
   RectTop = TextHeight("X") / 2 + HeightAdj / 2
   RectBottom = RectTop + TextHeight("X") * WinHeight

   StatusLineY = ScaleHeight - ((TextHeight("X") * 3) / 2)

   Return

Rem *************************************************
Rem Display the Status line
Rem *************************************************
DisplayStatus:

   Dim SpaceLen

   CurrentX = RectLeft
   CurrentY = StatusLineY

   SpaceLen = WinWidth - Len(StatusLine)
   If SpaceLen < 0 Then SpaceLen = 0

   Rem Print status in RED color
   ForeColor = RGB(255, 0, 0)
   

   Print StatusLine & Space$(SpaceLen)
   
   ForeColor = RGB(0, 0, 0)

   Return

Rem *************************************************
Rem Display the text lines
Rem *************************************************
DisplayLines:
   Dim i As Integer
   Dim row As Integer, col As Integer
   Dim BeginCol As Integer, StartRow As Integer
   Dim PrintLine As String
   Dim PrintLineLen As Integer

   Rem print the current line and previous 2 lines in the text windos
   row = 0
   BeginCol = 0
   StartRow = MAX_LINES - WinHeight
   i = CurLine + 1

   ForeColor = RGB(0, 0, 255) ' print in blue color
   
   Do                        ' print each line
     If i >= MAX_LINES Then i = 0
     If i = CurLine Then ' determine the starting location of the current line
        Rem The beginning should be should that the entire
        Rem word can be seen in the text window
        If LineLen <= WinWidth Then BeginCol = 0
        Else: BeginCol = (WordIndex + WordLen + 5) - WinWidth
        If BeginCol < 0 Then BeginCol = 0
     End If

     If (row >= StartRow) Then
        CurrentX = RectLeft
        CurrentY = RectTop + (row - StartRow) * TextHeight("X")
        PrintLineLen = Len(TextLine(i))
        If (PrintLineLen > BeginCol) Then
           PrintLine = Right(TextLine(i), PrintLineLen - BeginCol)
           Print PrintLine
        End If
     End If

     If (i = CurLine) Then
        If (row >= StartRow) Then
           ForeColor = RGB(255, 0, 0) ' highlight the misspelled word
           
           CurrentY = RectTop + (row - StartRow) * TextHeight("X")
           CurrentX = RectLeft + (WordIndex - BeginCol) * TextWidth("X")
           Print CurWord
        End If

        Exit Do
     End If

     i = i + 1
     row = row + 1
   Loop

   ForeColor = RGB(0, 0, 0)
   
   Return

End Sub

Private Sub Form_Resize()
   Cls
   Form_paint
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Dim temp As Integer

   ' save the changes to the user dictionary
   temp = StResetUserDict(ByVal 0&, ByVal 0&)

End Sub

Rem **************************************************
Rem Return an output file name consisting of the
Rem input file name with the given extension
Rem **************************************************
Private Function ModifyExt(InputFile As String, NewExt As String) As String
  Dim i As Integer
  Dim NameLen
  Dim CurChar

  NameLen = Len(InputFile)

  For i = NameLen To i = 1 Step -1
   CurChar = Left(InputFile, i)   ' access the current character
   CurChar = Right(CurChar, 1)

   If CurChar = "." Then
      ModifyExt = Left(InputFile, i - 1) & NewExt
      Exit Function
   End If
   If CurChar = "\" Or CurChar = ":" Then Exit For
  Next i
  ModifyExt = InputFile & NewExt     ' extension not found
End Function

  

Private Sub Word_Click()
   FormWord.Show
   
   
End Sub

